package com.ruoyi.system.domain.task;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class TkCommonQianpiExample implements Serializable {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private static final long serialVersionUID = 1L;

    public TkCommonQianpiExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    protected abstract static class GeneratedCriteria implements Serializable {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andTkIdIsNull() {
            addCriterion("tk_id is null");
            return (Criteria) this;
        }

        public Criteria andTkIdIsNotNull() {
            addCriterion("tk_id is not null");
            return (Criteria) this;
        }

        public Criteria andTkIdEqualTo(String value) {
            addCriterion("tk_id =", value, "tkId");
            return (Criteria) this;
        }

        public Criteria andTkIdNotEqualTo(String value) {
            addCriterion("tk_id <>", value, "tkId");
            return (Criteria) this;
        }

        public Criteria andTkIdGreaterThan(String value) {
            addCriterion("tk_id >", value, "tkId");
            return (Criteria) this;
        }

        public Criteria andTkIdGreaterThanOrEqualTo(String value) {
            addCriterion("tk_id >=", value, "tkId");
            return (Criteria) this;
        }

        public Criteria andTkIdLessThan(String value) {
            addCriterion("tk_id <", value, "tkId");
            return (Criteria) this;
        }

        public Criteria andTkIdLessThanOrEqualTo(String value) {
            addCriterion("tk_id <=", value, "tkId");
            return (Criteria) this;
        }

        public Criteria andTkIdLike(String value) {
            addCriterion("tk_id like", value, "tkId");
            return (Criteria) this;
        }

        public Criteria andTkIdNotLike(String value) {
            addCriterion("tk_id not like", value, "tkId");
            return (Criteria) this;
        }

        public Criteria andTkIdIn(List<String> values) {
            addCriterion("tk_id in", values, "tkId");
            return (Criteria) this;
        }

        public Criteria andTkIdNotIn(List<String> values) {
            addCriterion("tk_id not in", values, "tkId");
            return (Criteria) this;
        }

        public Criteria andTkIdBetween(String value1, String value2) {
            addCriterion("tk_id between", value1, value2, "tkId");
            return (Criteria) this;
        }

        public Criteria andTkIdNotBetween(String value1, String value2) {
            addCriterion("tk_id not between", value1, value2, "tkId");
            return (Criteria) this;
        }

        public Criteria andLeaderUserIdIsNull() {
            addCriterion("leader_user_id is null");
            return (Criteria) this;
        }

        public Criteria andLeaderUserIdIsNotNull() {
            addCriterion("leader_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andLeaderUserIdEqualTo(String value) {
            addCriterion("leader_user_id =", value, "leaderUserId");
            return (Criteria) this;
        }

        public Criteria andLeaderUserIdNotEqualTo(String value) {
            addCriterion("leader_user_id <>", value, "leaderUserId");
            return (Criteria) this;
        }

        public Criteria andLeaderUserIdGreaterThan(String value) {
            addCriterion("leader_user_id >", value, "leaderUserId");
            return (Criteria) this;
        }

        public Criteria andLeaderUserIdGreaterThanOrEqualTo(String value) {
            addCriterion("leader_user_id >=", value, "leaderUserId");
            return (Criteria) this;
        }

        public Criteria andLeaderUserIdLessThan(String value) {
            addCriterion("leader_user_id <", value, "leaderUserId");
            return (Criteria) this;
        }

        public Criteria andLeaderUserIdLessThanOrEqualTo(String value) {
            addCriterion("leader_user_id <=", value, "leaderUserId");
            return (Criteria) this;
        }

        public Criteria andLeaderUserIdLike(String value) {
            addCriterion("leader_user_id like", value, "leaderUserId");
            return (Criteria) this;
        }

        public Criteria andLeaderUserIdNotLike(String value) {
            addCriterion("leader_user_id not like", value, "leaderUserId");
            return (Criteria) this;
        }

        public Criteria andLeaderUserIdIn(List<String> values) {
            addCriterion("leader_user_id in", values, "leaderUserId");
            return (Criteria) this;
        }

        public Criteria andLeaderUserIdNotIn(List<String> values) {
            addCriterion("leader_user_id not in", values, "leaderUserId");
            return (Criteria) this;
        }

        public Criteria andLeaderUserIdBetween(String value1, String value2) {
            addCriterion("leader_user_id between", value1, value2, "leaderUserId");
            return (Criteria) this;
        }

        public Criteria andLeaderUserIdNotBetween(String value1, String value2) {
            addCriterion("leader_user_id not between", value1, value2, "leaderUserId");
            return (Criteria) this;
        }

        public Criteria andLeaderUserNameIsNull() {
            addCriterion("leader_user_name is null");
            return (Criteria) this;
        }

        public Criteria andLeaderUserNameIsNotNull() {
            addCriterion("leader_user_name is not null");
            return (Criteria) this;
        }

        public Criteria andLeaderUserNameEqualTo(String value) {
            addCriterion("leader_user_name =", value, "leaderUserName");
            return (Criteria) this;
        }

        public Criteria andLeaderUserNameNotEqualTo(String value) {
            addCriterion("leader_user_name <>", value, "leaderUserName");
            return (Criteria) this;
        }

        public Criteria andLeaderUserNameGreaterThan(String value) {
            addCriterion("leader_user_name >", value, "leaderUserName");
            return (Criteria) this;
        }

        public Criteria andLeaderUserNameGreaterThanOrEqualTo(String value) {
            addCriterion("leader_user_name >=", value, "leaderUserName");
            return (Criteria) this;
        }

        public Criteria andLeaderUserNameLessThan(String value) {
            addCriterion("leader_user_name <", value, "leaderUserName");
            return (Criteria) this;
        }

        public Criteria andLeaderUserNameLessThanOrEqualTo(String value) {
            addCriterion("leader_user_name <=", value, "leaderUserName");
            return (Criteria) this;
        }

        public Criteria andLeaderUserNameLike(String value) {
            addCriterion("leader_user_name like", value, "leaderUserName");
            return (Criteria) this;
        }

        public Criteria andLeaderUserNameNotLike(String value) {
            addCriterion("leader_user_name not like", value, "leaderUserName");
            return (Criteria) this;
        }

        public Criteria andLeaderUserNameIn(List<String> values) {
            addCriterion("leader_user_name in", values, "leaderUserName");
            return (Criteria) this;
        }

        public Criteria andLeaderUserNameNotIn(List<String> values) {
            addCriterion("leader_user_name not in", values, "leaderUserName");
            return (Criteria) this;
        }

        public Criteria andLeaderUserNameBetween(String value1, String value2) {
            addCriterion("leader_user_name between", value1, value2, "leaderUserName");
            return (Criteria) this;
        }

        public Criteria andLeaderUserNameNotBetween(String value1, String value2) {
            addCriterion("leader_user_name not between", value1, value2, "leaderUserName");
            return (Criteria) this;
        }

        public Criteria andUserIdIsNull() {
            addCriterion("user_id is null");
            return (Criteria) this;
        }

        public Criteria andUserIdIsNotNull() {
            addCriterion("user_id is not null");
            return (Criteria) this;
        }

        public Criteria andUserIdEqualTo(String value) {
            addCriterion("user_id =", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotEqualTo(String value) {
            addCriterion("user_id <>", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdGreaterThan(String value) {
            addCriterion("user_id >", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdGreaterThanOrEqualTo(String value) {
            addCriterion("user_id >=", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLessThan(String value) {
            addCriterion("user_id <", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLessThanOrEqualTo(String value) {
            addCriterion("user_id <=", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLike(String value) {
            addCriterion("user_id like", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotLike(String value) {
            addCriterion("user_id not like", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdIn(List<String> values) {
            addCriterion("user_id in", values, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotIn(List<String> values) {
            addCriterion("user_id not in", values, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdBetween(String value1, String value2) {
            addCriterion("user_id between", value1, value2, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotBetween(String value1, String value2) {
            addCriterion("user_id not between", value1, value2, "userId");
            return (Criteria) this;
        }

        public Criteria andUserNameIsNull() {
            addCriterion("user_name is null");
            return (Criteria) this;
        }

        public Criteria andUserNameIsNotNull() {
            addCriterion("user_name is not null");
            return (Criteria) this;
        }

        public Criteria andUserNameEqualTo(String value) {
            addCriterion("user_name =", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameNotEqualTo(String value) {
            addCriterion("user_name <>", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameGreaterThan(String value) {
            addCriterion("user_name >", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameGreaterThanOrEqualTo(String value) {
            addCriterion("user_name >=", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameLessThan(String value) {
            addCriterion("user_name <", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameLessThanOrEqualTo(String value) {
            addCriterion("user_name <=", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameLike(String value) {
            addCriterion("user_name like", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameNotLike(String value) {
            addCriterion("user_name not like", value, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameIn(List<String> values) {
            addCriterion("user_name in", values, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameNotIn(List<String> values) {
            addCriterion("user_name not in", values, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameBetween(String value1, String value2) {
            addCriterion("user_name between", value1, value2, "userName");
            return (Criteria) this;
        }

        public Criteria andUserNameNotBetween(String value1, String value2) {
            addCriterion("user_name not between", value1, value2, "userName");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andNoteIsNull() {
            addCriterion("note is null");
            return (Criteria) this;
        }

        public Criteria andNoteIsNotNull() {
            addCriterion("note is not null");
            return (Criteria) this;
        }

        public Criteria andNoteEqualTo(String value) {
            addCriterion("note =", value, "note");
            return (Criteria) this;
        }

        public Criteria andNoteNotEqualTo(String value) {
            addCriterion("note <>", value, "note");
            return (Criteria) this;
        }

        public Criteria andNoteGreaterThan(String value) {
            addCriterion("note >", value, "note");
            return (Criteria) this;
        }

        public Criteria andNoteGreaterThanOrEqualTo(String value) {
            addCriterion("note >=", value, "note");
            return (Criteria) this;
        }

        public Criteria andNoteLessThan(String value) {
            addCriterion("note <", value, "note");
            return (Criteria) this;
        }

        public Criteria andNoteLessThanOrEqualTo(String value) {
            addCriterion("note <=", value, "note");
            return (Criteria) this;
        }

        public Criteria andNoteLike(String value) {
            addCriterion("note like", value, "note");
            return (Criteria) this;
        }

        public Criteria andNoteNotLike(String value) {
            addCriterion("note not like", value, "note");
            return (Criteria) this;
        }

        public Criteria andNoteIn(List<String> values) {
            addCriterion("note in", values, "note");
            return (Criteria) this;
        }

        public Criteria andNoteNotIn(List<String> values) {
            addCriterion("note not in", values, "note");
            return (Criteria) this;
        }

        public Criteria andNoteBetween(String value1, String value2) {
            addCriterion("note between", value1, value2, "note");
            return (Criteria) this;
        }

        public Criteria andNoteNotBetween(String value1, String value2) {
            addCriterion("note not between", value1, value2, "note");
            return (Criteria) this;
        }
    }

    public static class Criteria extends GeneratedCriteria implements Serializable {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion implements Serializable {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}